package org.greenstone.admin.gui;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.GridLayout;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.Writer;

import javax.swing.*;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.transform.OutputKeys;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

//import org.apache.tools.ant.Project;
//import org.apache.tools.ant.ProjectHelper;
import org.greenstone.gsdl3.util.GSPath;
import org.greenstone.gsdl3.util.GlobalProperties;

import org.tmatesoft.svn.examples.wc.WorkingCopy;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.Text;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Iterator;
import java.util.Properties;
import java.util.Set;


class ExtensionInstallation extends Thread {
    
    Mat adaptee;
	
    public ExtensionInstallation (Mat m){
	adaptee = m;
    }
    
    public void run() {
    	try{
	    
	    String gsdl3Home = adaptee.get_GSDL3HOME();
	    String fileSeparator = File.separator;
            
	    File wd = new File(adaptee.extension_path);
	    Process proc = null;
	    
	    try {
		
		if(adaptee.os_type.toLowerCase().contains("windows")){
		    String[] arrays = {"ant.bat", "compile"};
		    proc = Runtime.getRuntime().exec(arrays, null, wd);
		}
		
		else{
		    proc = Runtime.getRuntime().exec("ant compile", null, wd);
		}
		
		BufferedReader stdInput = new BufferedReader(new InputStreamReader(proc.getInputStream()));
		BufferedReader errInput = new BufferedReader(new InputStreamReader(proc.getErrorStream()));
		String s= "";
		
		ExtPane.message_textarea.setText("");
		
		while ((s = stdInput.readLine()) != null) {
		    ExtPane.message_textarea.append(s+"\n");
		    ExtPane.message_textarea.setSelectionEnd(ExtPane.message_textarea.getDocument().getLength());
		}  
		
		while ((s = errInput.readLine()) != null) {
		    System.out.println(s);   
		}  
		
		ExtPane.message_textarea.append(adaptee.InstallCompleteMsg+"\n");
		
		Calendar cl;
		SimpleDateFormat sdf;    
		cl=Calendar.getInstance(); 
		sdf = new SimpleDateFormat("dd/MMM/yyyy 'at' HH:mm:ss z 'GMT'Z");
		String timestamp = sdf.format(cl.getTime());
		
		ExtPane.message_textarea.append(timestamp);
    		proc.waitFor();
		
    		JOptionPane.showMessageDialog(new JFrame(),adaptee.InstallCompleteMsg);
		ExtPane.updateExtensionContentPane();
		
	    } catch (Exception e) {
		JOptionPane.showMessageDialog(new JFrame(),adaptee.InstallErrorMsg);	
	    }
	    
    	}catch(Exception ex){
	    ex.printStackTrace();
    	}
    }
} 
